package tech.nevets.quickflags;

public class FlagFactory {

    public static Flag createFlag(String longFlag) {
        return new Flag() {
            @Override
            public String getLongFlag() {
                return longFlag;
            }
        };
    }

    public static Flag createFlag(String longFlag, char shortFlag) {
        return new Flag() {
            @Override
            public String getLongFlag() {
                return longFlag;
            }

            @Override
            public char getShortFlag() {
                return shortFlag;
            }
        };
    }

    public static Flag createFlag(String name, String longFlag, char shortFlag) {
        return new Flag() {
            @Override
            public char getShortFlag() {
                return shortFlag;
            }

            @Override
            public String getLongFlag() {
                return longFlag;
            }

            @Override
            public String getName() {
                return name;
            }
        };
    }
}
