package tech.nevets.quickflags;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class FlagHandler {

    private boolean debug = false;
    private final List<Flag> flags;
    private String[] remainingArgs;

    public FlagHandler() {
        flags = new ArrayList<>();
    }

    public FlagHandler registerFlag(Flag flag) {
        flags.add(flag);
        return this;
    }

    //TODO add more debug output
    public void setDebug(boolean debug) {
        this.debug = debug;
    }

    //TODO BUG: calculating remaining args no worky rn
    public void loadArgs(String[] args) {
        if (args.length == 0) return;
        boolean nextIsValue = false;
        int flagIndex = -1;
        int lastFlagIndex = -1;

        int index = 0;
        for (String s : args) {
            if (args.length < 2) {
                lastFlagIndex = -2;
                break;
            }
            if (nextIsValue) {
                flags.get(flagIndex).setValue(s);
                nextIsValue = false;
                continue;
            }

            if (s.startsWith("--")) {
                for (Flag f : flags) {
                    if (f.getLongFlag().equals(s.substring(2))) {
                        flagIndex = flags.indexOf(f);
                        nextIsValue = true;
                        lastFlagIndex = index;
                        break;
                    }
                }
            } else if (s.startsWith("-")) {
                for (Flag f : flags) {
                    if (f.getShortFlag() == s.charAt(1)) {
                        flagIndex = flags.indexOf(f);
                        nextIsValue = true;
                        lastFlagIndex = index;
                        break;
                    }
                }
            }
            index++;
        }

        remainingArgs = Arrays.copyOfRange(args, lastFlagIndex + 2, args.length);
    }

    public String getValue(String flagName) {
        for (Flag f : flags) {
            if (f.getName().equals(flagName)) {
                return f.getValue();
            }
        }
        if (debug) {
            System.out.println("DEBUG: No value found for flag \"" + flagName + "\"");
        }
        return "";
    }

    public String[] getRemainingArgs() {
        return this.remainingArgs;
    }

}
